#include "stdafx.h"

#include <grts/structs.db.h>

#include <grtpp_util.h>
#include <grtpp_undo_manager.h>

#include "grt/common.h"

//================================================================================
// db_DatabaseObject


void db_DatabaseObject::init()
{
}

void db_DatabaseObject::set_data(ImplData *data)
{
  _data= data;
}

db_DatabaseObject::~db_DatabaseObject()
{
}

void db_DatabaseObject::lastChangeDate(const grt::StringRef &value)
{
  grt::ValueRef ovalue(_lastChangeDate);

  _lastChangeDate= value;
  
  member_changed("lastChangeDate", ovalue, value);

  if (_owner.is_valid() && _owner.is_instance(db_Schema::static_class_name()))
  {
    db_SchemaRef schema(db_SchemaRef::cast_from(_owner));
    schema->signal_refreshDisplay().emit(this);
  }
}


void db_DatabaseObject::name(const grt::StringRef &value)
{
  grt::UndoManager *um= 0;
  grt::StringRef oname(_name);

  if (is_global() && !get_grt()->tracking_changes())
    um= get_grt()->get_undo_manager();

  if (um)
    um->begin_undo_group();
  _name= value;
  if (um)
    um->add_undo(new grt::UndoObjectChangeAction(this, "lastChangeDate"));
  _lastChangeDate= bec::fmttime(0, DATETIME_FMT);

  member_changed("name", oname, value);

  if (um)
  {
    um->end_undo_group();
    um->set_action_description(strfmt(_("Rename '%s' to '%s'"), 
      oname.c_str(), value.c_str())); 
  }
  

  if (_owner.is_valid() && _owner.is_instance(db_Schema::static_class_name()))
  {
    db_SchemaRef schema(db_SchemaRef::cast_from(_owner));
    schema->signal_refreshDisplay().emit(this);
  }
}





