#include "stdafx.h"

#include <grts/structs.workbench.physical.h>
#include <grts/structs.workbench.h>

#include <grtpp_util.h>
#include <grtpp_undo_manager.h>

#include "wbcanvas/workbench_physical_model_impl.h"
#include "wbcanvas/model_view_impl.h"


//================================================================================
// workbench_physical_Model


void workbench_physical_Model::init()
{
  if (!_data) _data= new workbench_physical_Model::ImplData(this);
  model_Model::set_data(_data);
}


void workbench_physical_Model::set_data(ImplData *data)
{
}

workbench_physical_Model::~workbench_physical_Model()
{
  delete _data;
}


model_ViewRef workbench_physical_Model::addNewView(long int defer_realize)
{
  grt::UndoManager *um= 0;
  
  if (is_global() && get_grt()->tracking_changes())
    um= get_grt()->get_undo_manager();

  model_ViewRef view;
  std::string name;

  name= grt::get_name_suggestion_for_list_object(_views, "EER Diagram", false);

  // calculate default size of view
  mdc::Size size= model_View::ImplData::get_size_for_page(get_data()->get_page_settings());

  size.width*=2; // 2 pages

  view= workbench_physical_ViewRef(get_grt());
  view->owner(this);
  view->name(name);
  view->width(size.width);
  view->height(size.height);
  view->zoom(1);

  if (um)
  {
    um->add_undo(new grt::UndoListInsertAction(_views));
    um->set_action_description(strfmt(_("New Diagram '%s'"), name.c_str()));
  }
  _views.insert(view);
  
  if (!defer_realize)
    view->get_data()->realize();

  return view;
}

