
#include "properties_tree.h"


PropertiesTree::PropertiesTree(wb::WBContextUI *wb)
  : _wb(wb), _inspector(0)
{
  pack_start(_combo, false, false);
  pack_start(_swin, true, true);

  _swin.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);
  _swin.add(_tree);
  _swin.set_shadow_type(Gtk::SHADOW_IN);
  _tree.set_headers_visible(true);

  show_all();
}


PropertiesTree::~PropertiesTree()
{
  delete _inspector;
}


void PropertiesTree::update()
{
  std::vector<std::string> items;
  
  _tree.remove_all_columns();
  _tree.unset_model();
  delete _inspector;
  _inspector= _wb->create_inspector_for_selection(_wb->get_active_main_form(), items);

  if (_inspector)
  {
    _model= ListModelWrapper::create(_inspector, &_tree, "PropertiesTree");
    _model->model().append_string_column(bec::ValueInspectorBE::Name, _("Name"), RO, WITH_ICON);
    _model->model().append_string_column(bec::ValueInspectorBE::Value, _("Value"), RO, WITH_ICON);
    _tree.set_model(_model);
  }

  _combo.clear_items();
  for (std::vector<std::string>::const_iterator iter= items.begin();
       iter != items.end(); ++iter)
  {
    _combo.append_text(*iter);
  }

  _combo.set_active(0);
}

