

#include "wb_editor_note.h"



NoteEditorBE::NoteEditorBE(bec::GRTManager *grtm, const workbench_model_NoteFigureRef &note)
: bec::BaseEditor(grtm, note), _note(note)
{
}




void NoteEditorBE::set_text(const std::string &text)
{
  if (add_undo_object_text_change(_note, "text"))
    get_undo_manager()->set_action_description(_("Change Note Text"));
  _note->text(text);
}


std::string NoteEditorBE::get_text()
{
  return _note->text();
}


void NoteEditorBE::set_name(const std::string &name)
{
  if (add_undo_object_text_change(_note, "name"))
    get_undo_manager()->set_action_description(_("Change Note Name"));
  _note->name(name);
}


std::string NoteEditorBE::get_name()
{
  return _note->name();
}
